#define _WINSOCKAPI_      // Prevent winsock.h from being included
#include <vcl\vcl.h>
#pragma hdrstop

#include "HttpDlg.h"
#include "Global.h"
#include "FileMan.h"
#include "UrlsDlg.h"
#include "Mixmaster.h"
#include "PgpMail.h"
#include "HelpDlg.h"
//---------------------------------------------------------------------------
#pragma link "HttpProt"
#pragma link "explbtn"
#pragma resource "*.dfm"
THttpForm *HttpForm;
//#define CHECKING " Error Checks "
#define hsleep 100
AnsiString httpretval;
//---------------------------------------------------------------------------
bool __fastcall GetRemailerStats(TForm *owner, bool attended)
{
   HttpForm = new THttpForm(owner);
   CenterDialog(HttpForm,owner);
   bool ok = HttpForm->Execute(attended);
   delete HttpForm;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall InType2(TStrings *type2, AnsiString &descrip)
{
   int pos=-1;
   for (int i=0; i<type2->Count; i++)
   {
      if (type2->Strings[i]==descrip)
      {
         pos = i;
         break;
      }
   }
   //sm(s(pos)+"  "+descrip);
   return pos>=0;
}
//---------------------------------------------------------------------------
char* __fastcall MixGetNewRemailerKeys(char *KeyDoc)
{
 // returns description lines of new, not disabled, keys
   AnsiString descrip,mtyp2txt=MixDir()+MTyp2Txt;
   TStringList *keydoc = new TStringList();
   keydoc->SetText(KeyDoc);

   TStringList *newkeys = new TStringList();
   TStringList *type2 = new TStringList(); type2->Sorted = true;
   TMixDb *curdb = new TMixDb(MixPublicRing());
   TMixDb *newdb = new TMixDb(keydoc);
   if (FileExists(mtyp2txt)) type2->LoadFromFile(mtyp2txt);
   TMixKey *key = newdb->FirstKey();
   while (key)
   {
      if (curdb->FindDescrip(key->Description)<0)
      {
         if (!InType2(type2,"#"+key->Description))
            newkeys->Add(key->Description);
      }
      key = key->Next;
   }
   httpretval = newkeys->Text;
   delete newdb;
   delete curdb;
   delete newkeys;
   delete type2;
   delete keydoc;
   return httpretval.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall MixAddNewRemailerKeys(char *KeyDoc)
{
 // returns new type2.list, puts updated doc in mringtmp
   AnsiString line,mtyp2txt=MixDir()+MTyp2Txt;
   TStringList *keydoc = new TStringList();
   keydoc->SetText(KeyDoc);

   TStringList *type2 = new TStringList(); type2->Sorted = true; type2->Duplicates = dupAccept; 
   TMixDb *curdb = new TMixDb(MixPublicRing());
   TMixDb *newdb = new TMixDb(keydoc);
   if (FileExists(mtyp2txt)) type2->LoadFromFile(mtyp2txt);
   TMixKey *key = newdb->FirstKey();
   // find new keys and add to curdb
   while (key)
   {
      if (curdb->FindDescrip(key->Description)<0)
      {
         if (!InType2(type2,"#"+key->Description))
            curdb->AddKey(new TMixKey(key));
      }
      key = key->Next;
   }
   // clear current type2 of all non-disabled remailers
   int c=0; while(c<type2->Count)
   {
      if (type2->Strings[c].Pos("#")==1) { c++; continue; }
      type2->Delete(c);
   }
   // get key descriptions for type2
   key = curdb->FirstKey();
   while (key)
   {
      if (!InType2(type2,"#"+key->Description))
         type2->Add(key->Description);
      key = key->Next;
   }
   // sort keys
   curdb->OrderBy(type2);
   curdb->SaveToFile(MRingTmp); // save keyring;
   httpretval = type2->Text;
   delete newdb;
   delete curdb;
   delete type2;
   delete keydoc;
 //sm(httpretval);
   return httpretval.c_str();
}
//---------------------------------------------------------------------------
__fastcall THttpForm::THttpForm(TComponent* Owner)
    : TForm(Owner)
{
   DocMemo->Font->Name = GetAppIni("FontName","Courier New");
   DocMemo->Font->Size = GetAppIni("FontSize","").ToIntDef(10);
   ErrorCheck->Checked = GetAppIni(StatsErrCheck,"").ToIntDef(1);
   CenterDialog(this);
   PageControl1->ActivePage = TabSheet1;
   Label1->Caption = "";

   LoadHttpInfo();
   HttpCli1->RcvdStream = NULL;
   Tabs = TabSet->Tabs;
   CancelAnyway = false;
   Cancelled = false;
   Attended = false;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   int goodtabs=0;
   AnsiString curdoc;
   if (TabSet->TabIndex>=0) // make sure tabdoc = docmemo
   {
      TStrings *tabdoc = dynamic_cast<TStrings*>(Tabs->Objects[TabSet->TabIndex]);
      if (tabdoc) tabdoc->Text = DocMemo->Lines->Text;
   }
   for (int i=0; i<Tabs->Count; i++)
   {
      TStrings *doc = dynamic_cast<TStrings*>(Tabs->Objects[i]);
      if (doc && doc->Count && doc->Text.Pos(CorruptReport)==1) continue;
      if (Tabs->Strings[i]=="Error") continue;
      goodtabs++;
   }
   if (ModalResult==mrOk && goodtabs)
   {
      SaveStatistics();
      if (MixKeyringHasDoubles()) Cancelled = true;
   }
   else
   if (Attended && ModalResult==mrCancel && goodtabs>0)// && GetBtn->Caption=="Done")
   {
      int reply = MsgBoxHwnd(Handle,"Your new remailer docs are not saved!\n\nSave them now?",
            "Remailer Documents",MB_YESNOCANCEL);
      switch (reply)
      {
         case ID_CANCEL: CanClose=false; break;
         case ID_YES:
            SaveStatistics();
            if (MixKeyringHasDoubles())
            {
               Cancelled = true;
               break;
            }
            ModalResult = mrOk;
            break;
      }
      if (!CanClose) return;
   }
   delete HttpCli1->RcvdStream;

   if (CancelAnyway) ModalResult = mrCancel;
// if (ModalResult!=mrCancel)
// {
      StoreHttpInfo();
      for (int i=0; i<Tabs->Count; i++)
         delete (TStringList*)Tabs->Objects[i];
      PutAppIni(StatsErrCheck,ErrorCheck->Checked ? "1":"0");
// }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer2Timer(TObject *Sender)
{
   Timer2->Enabled = false;
   GetBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormShow(TObject *Sender)
{
   GetAppURLs();
   ActiveControl = Panel2;
   if (!Attended)
   {
      //Label7->Visible = false;
      PageControl1->ActivePage = TabSheet3;
      Application->ProcessMessages();
      Timer2->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetBtnClick(TObject *Sender)
{
   if (Cancelled)
   {
      ResetCheckboxes();
      return;
   }

   if (!Timer1->Enabled) Timer1->Enabled = true;
   if (GetBtn->Enabled && GetBtn->Caption=="Get Docs")
   {
      TabSheet1->Enabled = false;
      TabSheet2->Enabled = false;
   }
   GetBtn->Enabled = false;
   OkBtn->Enabled = false;

   if (MListBox->Enabled && MListBox->Checked)
      GetStatistics(MListURL,MListBox,MListTxt);
   else
   if (MRingBox->Enabled && MRingBox->Checked)
      GetStatistics(MRingURL,MRingBox,MRingTxt);
   else
   if (MTyp2Box->Enabled && MTyp2Box->Checked)
      GetStatistics(MTyp2URL,MTyp2Box,MTyp2Txt);
   else
   if (CListBox->Enabled && CListBox->Checked)
      GetStatistics(CListURL,CListBox,CListTxt);
   else
   if (CRingBox->Enabled && CRingBox->Checked)
      GetStatistics(CRingURL,CRingBox,CRingTxt);
   else
   {
      ResetCheckboxes();
      ProgressBar1->Visible = false;
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      PageControl1->ActivePage = TabSheet3;

      if (ErrorCheck->Checked)
      {
         bool ok1=true,ok2=true,ok3=true,ok4=true,ok5=true;
         for (int i=0; i<Tabs->Count; i++)
         {
            TStringList *doc = dynamic_cast<TStringList*>(Tabs->Objects[i]);
            if (doc)
            {
               if (Tabs->Strings[i]==MListTxt) ok1=MListOk(doc); else
               if (Tabs->Strings[i]==MRingTxt) ok2=MRingOk(doc); else
               if (Tabs->Strings[i]==MTyp2Txt) ok3=MTyp2Ok(doc); else
               if (Tabs->Strings[i]==CListTxt) ok4=CListOk(doc); else
               if (Tabs->Strings[i]==CRingTxt) ok4=CRingOk(doc);
            }
         }
         if (!ok1 || !ok2 || !ok3 || !ok4 || !ok5)
         {
            CancelAnyway = true;
            Cancelled = true;
            Attended = true;
            GetBtn->Click();
         }
      }

      ActiveControl = DocMemo;
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      UrlsBtn->Enabled = true;
      OkBtn->Enabled = true;
      Label1->Caption = "";
      Cancelled = false;

      if (Attended) MyBeep(MB_OK);
      else
      {
         ProgressBar1->Visible = false;
         CancelBtn->Enabled = false;
         OkBtn->Enabled = false;
         SaveStatistics();        // could have gotten valid page before cancel
         if (MixKeyringHasDoubles()) Cancelled = true;
         Sleep(1000);
         ModalResult = !Cancelled || (Cancelled && TabSet->Tabs->Count>1) ?
            mrOk : mrCancel;
      }
   }
}
//---------------------------------------------------------------------------
TStringList* __fastcall THttpForm::GetDoc(AnsiString &Docname)
{
   int pos;
   TStringList *Doc=NULL;
   if ((pos=Tabs->IndexOf(Docname))>=0)
   {
      (TStrings*)Doc = dynamic_cast<TStrings*>(Tabs->Objects[pos]);
      if (Doc && Doc->Count) return Doc;
   }
   else
   if (FileExists(MixDir()+Docname))
   {
      Doc = new TStringList();
      Doc->LoadFromFile(MixDir()+Docname);
      Tabs->AddObject(Docname,Doc);
      return Doc;
   }
   return Doc;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::GotDoc(AnsiString &Docname)
{
   return Tabs->IndexOf(Docname)>=0 ? true:false;
}
//---------------------------------------------------------------------------
void __fastcall LogAdd(AnsiString &msg, TStrings *Log)
{
   Log->Add(msg); Sleep(hsleep);
}
//---------------------------------------------------------------------------
bool __fastcall MRingLineOk(AnsiString &line)
{
   int fld=0;
   bool ok=true;
   AnsiString data;
   while (ok && !(data=GetParam(fld,line," ")).IsEmpty())
   {
      if (fld==1 && data.Pos("@")<1) ok = false;
      if (fld==3 && data.Pos(".")<1) ok = false;
      fld++;
   }
   if (fld!=4 && fld!=5) ok = false;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall CRingLineOk(AnsiString &line)
{
   return GetParam(1,line," ").Pos("0x")==1;
}
//---------------------------------------------------------------------------
bool __fastcall GenerateType1List(TStrings *Keys) // keys in individual keyy blocks
{
   TStringList *rlist = new TStringList();
   TStringList *type1 = new TStringList(); type1->Sorted = true;
   AnsiString shortname,tline,rline,adrs,
      ctyp1txt=MixDir()+CTyp1Txt,rlisttxt=MixDir()+CListTxt;
   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);
   int i=0; while (i<type1->Count)
   {
      if (type1->Strings[i].Pos("#")!=1) type1->Delete(i);
      else i++;
   }
   for (i=0; i<Keys->Count; i++)
   {
      AnsiString line = Keys->Strings[i];
      if (CRingLineOk(line) && type1->IndexOf("#"+line)<0)
         type1->Add(line);
   }
   type1->Sorted = false;
   AnsiString noshort = "@NO_SHORT_NAME_FOUND";
   TStringList *badlines = new TStringList();
   rlist->LoadFromFile(rlisttxt);
   for (int t=0; t<type1->Count; t++)
   {
      shortname = noshort;
      tline = GetParam(0,type1->Strings[t]," ");
      adrs = GetParam(0,tline,"/");
      for (int r=0; r<rlist->Count; r++)
      {
         rline = rlist->Strings[r];
         if (rline.Trim().Pos("$remailer{")!=1) continue;
         if (rline.Pos(adrs)>0)
         {
            shortname=GetParam(1,rline,"\"");
            if (shortname.IsEmpty()) shortname = GetParam(1,rline,"'");
            if (shortname.IsEmpty()) shortname = noshort;
            else break;
         }
      }
      if (shortname==noshort) badlines->Add(shortname+" "+tline);
      type1->Strings[t] = shortname+" "+type1->Strings[t];
   }
   type1->Sorted = true;
   if (badlines->Count)
   {
      AnsiString badcount=badlines->Count==1?s("is 1 remailer"):s("are "+s(badlines->Count)+" remailers ");
      MsgBox(
         s("=====================TYPE1.LIST ERROR=====================\n")+
         s("\nIn generating the file 'type1.list' I found that there "+badcount+" without\n")+
         s("corresponding short names in rlist.txt. Please have a look for yourself. After\n")+
         s("you close this dialog click 'View|rlist.txt' and 'View|type1.list' to examine the\n")+
         s("problem.\n \n \n"+badlines->Text+"\n \n "),
         CTyp1Txt.LowerCase(),
         MB_OK
      );
   }
   type1->SaveToFile(ctyp1txt);
   bool ok = !badlines->Count;
   delete badlines;
   delete type1;
   delete rlist;
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall GenerateType2List(TStrings *Keys) // keys in individual keyy blocks
{
   TStringList *type2 = new TStringList(); type2->Sorted = true;
   AnsiString mtyp2txt = MixDir()+MTyp2Txt;
   if (FileExists(mtyp2txt)) type2->LoadFromFile(mtyp2txt);
   int i=0; while (i<type2->Count)
   {
      if (type2->Strings[i].Pos("#")!=1) type2->Delete(i);
      else i++;
   }
   for (i=0; i<Keys->Count; i++)
   {
      AnsiString line = Keys->Strings[i];
      if (MRingLineOk(line) && type2->IndexOf("#"+line)<0)
         type2->Add(line);
   }
   type2->SaveToFile(mtyp2txt);
   delete type2;
}
//---------------------------------------------------------------------------
AnsiString MRingCnt(int val)
{
   AnsiString v=AnsiString(val);
   if (v.Length()<2) v = " "+v; return v;
}
//---------------------------------------------------------------------------
bool __fastcall MListLineOk(AnsiString &line)
{
   return (line.Length()==44 && line[34]==':' && line[41]=='.' && line[44]=='%');
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr)
{
   fromStr = fromStr.Trim();
   int p = fromStr.Pos(" ");
   AnsiString prm=fromStr.Trim().SubString(1,p-1);
   if (pos>0) return GetParamSpc(pos-1,fromStr.SubString(p,256));
   return prm;
}
//---------------------------------------------------------------------------
bool __fastcall CListLineOk(AnsiString &line)
{
 //"redneck  config@redneck.gacracker.org     ###***##*###      :27 100.00%"
   int l=line.Length();
   AnsiString addr = GetParamSpc(1,line);
   bool ok = addr.Pos("@");
   if (ok) ok = l && line[l-10]==':';
   if (ok) ok = l && line[l-3]=='.';
   if (ok) ok = l && line[l]=='%';
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CRingOk(TStrings *Doc)
{
   bool ok1=Doc->IndexOf("-----BEGIN PGP PUBLIC KEY BLOCK-----")>=0;
   bool ok2=Doc->IndexOf("-----END PGP PUBLIC KEY BLOCK-----")>=0;
   if (!ok1 || !ok2)
   {
      AnsiString badline;
      if (!ok1 && !ok2)
         badline = "both first and last lines are"; else
      if (!ok1) badline = "the first line is"; else
      if (!ok2) badline = "the last line is";
      TabSet->TabIndex = Tabs->IndexOf(CRingTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n\n")+
         s("This 'pubring.asc' document appears corrupt. The first line\n")+
         s("should be:\n\n")+
         s("  \"-----BEGIN PGP PUBLIC KEY BLOCK-----\"\n\n")+
         s("and the last line:\n\n")+
         s("  \"-----END PGP PUBLIC KEY BLOCK-----\"\n\n")+
         s("In this document, "+badline+" not correct.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         CRingTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   if (!HasPgp()) return true;

   TStringList *newkeys = new TStringList();
   newkeys->SetText(PgpGetNewRemailerKeys(Doc->Text.c_str()));
   newkeys->Sorted = true;
   // notify of new keys, if any
   if (newkeys->Count)
   {
      TStringList *msg = new TStringList();
      AnsiString s = newkeys->Count==1 ? "" : "s";
      TabSet->TabIndex = Tabs->IndexOf(CRingTxt);
      AppProcessMessages(); Sleep(300);
      msg->Add("====================NEW CYBERPUNK KEYS====================");
      msg->Add("\nThe following new key"+s+" will be added to your Cyberpunk keyring.\n");
      for (int i=0; i<newkeys->Count; i++)
      {
         AnsiString descrip="";
         for (int f=0; f<5; f++)
             if (f!=2) descrip += "  "+GetParam(f,newkeys->Strings[i]," ");
         msg->Add(newkeys->Strings[i]);
      }
      msg->Add("\nAny remaining keys in this document will be discarded. \n \n \n");// since you already");
      //msg->Add("have them or don't want them.\n \n \n");
      MsgBoxHwnd(Handle,msg->Text,CRingTxt.LowerCase(),MB_OK);
      delete msg;
   }
   delete newkeys;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CListOk(TStrings *Doc)
{
   AnsiString statsheader =
      s("remailer  email address                        history  latency  uptime\r\n")+
      s("-----------------------------------------------------------------------\r\n");
   int i,pos;
   while ((pos=Doc->Text.Pos("&lt;"))>0) Doc->Text.Delete(pos,4);
   while ((pos=Doc->Text.Pos("&gt;"))>0) Doc->Text.Delete(pos,4);
   if (Doc->Text.Pos(statsheader)==0)
   {
      TabSet->TabIndex = Tabs->IndexOf(CListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(100);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'rlist.txt' document appears corrupt. I'm unable to\n")+
         s("locate the statistics column headings. They should look\n")+
         s("like this:\n\n")+
         s("\"remailer  email address                        history  latency  uptime\"\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         CListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   int c=0;
   for (i=0; i<Doc->Count; i++)
      if (CListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      TabSet->TabIndex = Tabs->IndexOf(CListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'rlist.txt' document appears corrupt. I've located\n")+
         s("the stats column headers, but found no actual stats lines\n")+
         s("at all.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         CListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MListOk(TStrings *Doc)
{
   AnsiString statsheader =
      s("mixmaster           history  latency  uptime\r\n")+
      s("--------------------------------------------\r\n");
   if (Doc->Text.Pos(statsheader)==0)
   {
      TabSet->TabIndex = Tabs->IndexOf(MListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(100);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'mlist.txt' document appears corrupt. I'm unable to\n")+
         s("locate the statistics column headings. They should look\n")+
         s("like this:\n\n")+
         s("\"mixmaster           history  latency  uptime\"\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   int c=0;
   for (int i=0; i<Doc->Count; i++)
      if (MListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      TabSet->TabIndex = Tabs->IndexOf(MListTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'mlist.txt' document appears corrupt. I've located\n")+
         s("the stats column headers, but found no actual stats lines\n")+
         s("at all.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MListTxt.LowerCase(),
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MRingOk(TStrings *Doc)
{
   int i,beg=0,end=0;
   AnsiString line,descrip,s;
   TStringList *des = new TStringList();
   for (i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      if (line=="-----Begin Mix Key-----") beg++; else
      if (line=="-----End Mix Key-----") end++; else
      if (MRingLineOk(line))
         des->Add(line);
   }
   if (!(des->Count>0 && des->Count==beg && beg==end))
   {
      TabSet->TabIndex = Tabs->IndexOf(MRingTxt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'pubring.mix' document appears corrupt. By my\n")+
         s("count there are:\n\n")+
         s(" "+MRingCnt(des->Count)+" Mix key description lines\n")+
         s(" "+MRingCnt(beg)+" Begin Mix Key lines\n")+
         s(" "+MRingCnt(end)+" End Mix Key lines\n\n")+
         s("These values should ALL be greater than 0 and equal.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MRingTxt.LowerCase(),
         MB_OK);
       delete des;
      return false;
   }
   delete des;

   // doc is ok, check for new keys
   TStringList *newkeys = new TStringList();
   newkeys->SetText(MixGetNewRemailerKeys(Doc->Text.c_str()));
   newkeys->Sorted = true;
   // notify of new keys, if any
   if (newkeys->Count)
   {
      TStringList *msg = new TStringList();
      s = newkeys->Count==1 ? "" : "s";
      TabSet->TabIndex = Tabs->IndexOf(MRingTxt);
      AppProcessMessages(); Sleep(300);
      msg->Add("===============NEW MIXMASTER KEYS==============");
      msg->Add("\nThe following new key"+s+" will be added to your Mixmaster keyring.\n");
      for (i=0; i<newkeys->Count; i++)
      {
         descrip = "";
         for (int f=0; f<5; f++)
             if (f!=2) descrip += "  "+GetParam(f,newkeys->Strings[i]," ");
         msg->Add(descrip.Trim());
      }
      msg->Add("\nAny remaining keys in this document will be discarded. \n \n \n");
      //, since you already have them or don't want");
      //msg->Add("them.\n \n \n");
      MsgBoxHwnd(Handle,msg->Text,MRingTxt.LowerCase(),MB_OK);
      delete msg;
   }
   delete newkeys;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MTyp2Ok(TStrings *Doc)
{
   int cnt=0;
   for (int i=0; i<Doc->Count; i++)
      if (MRingLineOk(Doc->Strings[i])) cnt++;
   if (cnt==0)
   {
      TabSet->TabIndex = Tabs->IndexOf(MTyp2Txt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'type2.list' document appears corrupt. I've scanned\n")+
         s("all "+s(Doc->Count)+" lines and found no mix key descriptions at all!\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MTyp2Txt.LowerCase(),
         MB_OK);
      return false;
   }
   if (cnt!=Doc->Count)
   {
      TabSet->TabIndex = Tabs->IndexOf(MTyp2Txt);
      DocMemo->Lines->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      MsgBoxHwnd(Handle,
         s("==============DOCUMENT ERROR==============\n")+
         s("\nThis 'type2.list' document appears corrupt. I've scanned\n")+
         s("all "+s(Doc->Count)+" lines and found only "+s(cnt)+" mix key descriptions! Every\n")+
         s("line should be a valid description.\n\n")+
         s("Please have a look for yourself. You may need to update\n")+
         s("from another source. This document has been marked\n")+
         s("so you can't accidentally save it. \n \n \n"),
         MTyp2Txt.LowerCase(),
         MB_OK);
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SaveStatistics()
{
   TStrings *TxtList;
   AnsiString TxtFile,descrip,line;
   int i,bakcopies=STATSBAKCOPIES,idx=TabSet->TabIndex;
   // copy current to tab stringlist to get possible edits
   if (idx>=0) ((TStringList*)Tabs->Objects[idx])->Text = DocMemo->Lines->Text;
   // process tabs
   for (i=0; i<TabSet->Tabs->Count; i++)
   {
      if ((TxtFile=Tabs->Strings[i])=="Error") continue;
      TxtList = dynamic_cast<TStrings*>(Tabs->Objects[i]);
      if (!TxtList || TxtList && TxtList->Count && TxtList->Text.Pos(CorruptReport)==1)
         continue;
      if (ErrorCheck->Checked)
      {
        // THIS IS THE MRINGTXT DOCUMENT
         if (TxtFile==MRingTxt)
         {
            TStringList *type2 = new TStringList(); //type2->Sorted = true;
            type2->SetText(MixAddNewRemailerKeys(TxtList->Text.c_str()));
            if (type2->Count && FileExists(MRingTmp))
            {
               TxtList->LoadFromFile(MRingTmp);
               DeleteFile(MRingTmp.c_str());
            }
            // save new type2
            SaveToFileBak(type2,MixDir()+MTyp2Txt,bakcopies);
            delete type2;
         }
         // THIS IS THE CRINGTXT DOCUMENT
         if (TxtFile==CRingTxt && HasPgp())
         {
            TStringList *type1 = new TStringList(); type1->Sorted = true;
            type1->SetText(PgpAddNewRemailerKeys(TxtList->Text.c_str()));
            if (type1->Count && FileExists(CRingTmp))
            {
               TxtList->LoadFromFile(CRingTmp);
               DeleteFile(CRingTmp.c_str());
            }
            // save new type1
            SaveToFileBak(type1,MixDir()+CTyp1Txt,bakcopies);
            delete type1;
         }
      }
      SaveToFileBak(TxtList,MixDir()+TxtFile,bakcopies);
   }
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixKeyringHasDoubles()
{
  int i,c;
  AnsiString s,id;
  TStringList *dbls = new TStringList();
  TStringList *type2 = new TStringList();
  type2->LoadFromFile(MixDir()+MTyp2Txt);
  for (i=0; i<type2->Count; i++)
  {
    if (type2->Strings[i].Pos("#")==1) continue;
    id = GetParam(2,type2->Strings[i]," ");
    if (dbls->Values[id].IsEmpty()) dbls->Values[id]="0";
    c = dbls->Values[id].ToIntDef(0)+1;
    dbls->Values[id] = AnsiString(c);
  }
  i=0; while(i<dbls->Count)
  {
    s = dbls->Strings[i];
    if (s.Pos("=1")==0)
    {
       dbls->Strings[i] = s.SubString(1,s.Pos("=")-1);
       i++;
    }
    else dbls->Delete(i);
  }
  if (!dbls->Count)
  {
     delete type2;
     delete dbls;
     return false;
  }
  TStringList *msg = new TStringList();
  msg->Add("=====================================Problem Keys=====================================\n");
  msg->Add("The following keys on your mixmaster keyring appear more than once. This would indicate the remailer");
  msg->Add("has probably changed configuration. You will need to determine which is current, and disable the older");
  msg->Add("key. To disable a key, put a '#' in front of the key's entry in 'type2.list'. This tells Mix and QS to ignore");
  msg->Add("the key in the future.\n");
  msg->Add("I'm sorry I cannot determine this for you, because the new key you have downloaded may actually be the");
  msg->Add("older of the duplicates. This can happen because not all stats/keys sources provide up to date keys. Take");
  msg->Add("a good look at them here. The proper choice may be evident. Then open type2.list (click 'View|type2.list'");
  msg->Add("on the QS main menu) and disable that key. Otherwise, disable BOTH until you can confirm which is");
  msg->Add("correct.\n\n");
  for (i=0; i<dbls->Count; i++)
  {
     for (c=0; c<type2->Count; c++)
     {
        if (type2->Strings[c].Pos(dbls->Strings[i])>0)
        msg->Add(type2->Strings[c]);
     }
     msg->Add("");
  }
  msg->Add(" \n \n");
  MsgBox(msg->Text,"Mixmaster",MB_OK);
  delete msg;
  delete type2;
  delete dbls;
  return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::GetStatistics(AnsiString &forURL, TCheckBox *Box,
   AnsiString &Doc)
{
   CurDoc = Doc;
   CurBox = Box;
   Cap = forURL;//+"...";
   Label1->Caption = Cap;
   //CancelBtn->Caption = "Cancel";
   HttpCli1->URL = forURL;
   HttpCli1->Proxy = ProxyHostEdit->Text;
   HttpCli1->ProxyPort = ProxyPortEdit->Text;
   HttpCli1->ProxyUsername = ProxyUserEdit->Text;
   HttpCli1->ProxyPassword = ProxyPswdEdit->Text;
   HttpCli1->ModifiedSince = 0;
   ProgressBar1->Position = 0;
   ProgressBar1->Visible = true;
   BytesReceived = 0;

   try {
       HttpCli1->HeadASync();
   } __except (TRUE) {
       GetBtn->Enabled = true; //SetButtonState(true);
       TabSheet1->Enabled = true;
       TabSheet2->Enabled = true;

       DocMemo->Clear();
       DocMemo->Lines->Add("Head Failed !");
       DocMemo->Lines->Add("Status = " + IntToStr(HttpCli1->StatusCode));
       DocMemo->Lines->Add("Reason = " + HttpCli1->ReasonPhrase);
       PageControl1->ActivePage = TabSheet3;
       ProgressBar1->Visible = false;
       return false;
   }
   return !Cancelled;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::LoadHttpInfo()
{
   TStringList *http = new TStringList();
   if (AppDataExists(HttpInfo,http))
   {
      //sm(http->Text);
      MListBox->Checked = http->Values["MListChkd"] == "1";
      MRingBox->Checked = http->Values["MRingChkd"] == "1";
      MTyp2Box->Checked = http->Values["MTyp2Chkd"] == "1";
      CListBox->Checked = http->Values["CListChkd"] == "1";
      CRingBox->Checked = http->Values["CRingChkd"] == "1";
      ProxyHostEdit->Text = http->Values["ProxyHost"];
      ProxyPortEdit->Text = http->Values["ProxyPort"];
      ProxyPswdEdit->Text = http->Values["ProxyPswd"];
      ProxyUserEdit->Text = http->Values["ProxyUser"];
   }
   Http = http->Text; // keep for later compare to see if modified
   delete http;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::StoreHttpInfo()
{
   TStringList *http = new TStringList();
   http->Add("MListChkd="+AnsiString(MListBox->Checked?"1":"0"));
   http->Add("MRingChkd="+AnsiString(MRingBox->Checked?"1":"0"));
   http->Add("MTyp2Chkd="+AnsiString(MTyp2Box->Checked?"1":"0"));
   http->Add("CListChkd="+AnsiString(CListBox->Checked?"1":"0"));
   http->Add("CRingChkd="+AnsiString(CRingBox->Checked?"1":"0"));
   http->Add("ProxyHost="+ProxyHostEdit->Text);
   http->Add("ProxyPort="+ProxyPortEdit->Text);
   http->Add("ProxyPswd="+ProxyPswdEdit->Text);
   http->Add("ProxyUser="+ProxyUserEdit->Text);
   if (Http!=http->Text) // test for modified
      PutAppData(HttpInfo,http);
   delete http;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::Execute(bool attended)
{
   Attended = attended; ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
//void __fastcall THttpForm::SetButtonState(bool enabled)
//{
//   GetBtn->Enabled = enabled;
//}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ResetCheckboxes()
{
   Timer1->Enabled = false;
   if (MListBox->Checked) MListBox->Enabled = true;
   if (MRingBox->Checked) MRingBox->Enabled = true;
   if (MTyp2Box->Checked) MTyp2Box->Enabled = true;
   if (CListBox->Checked) CListBox->Enabled = true;
   if (CRingBox->Checked) CRingBox->Enabled = true;
   if (Attended) GetBtn->Enabled = true; //SetButtonState(true);
   TabSheet1->Enabled = true;
   TabSheet2->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocBegin(TObject *Sender)
{
   BytesReceived = 0;
   ProgressBar1->Position = 0;
   if (HttpCli1->RcvdStream) delete HttpCli1->RcvdStream;
   HttpCli1->RcvdStream = new TMemoryStream();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len)
{
   if (BytesTotal>0)
   {
      BytesReceived += Len;
      ProgressBar1->Position = (BytesReceived/BytesTotal)*100;
      Sleep(200);
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocEnd(TObject *Sender)
{
   ProgressBar1->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1RequestDone(TObject *Sender,
	THttpRequest RqType, WORD Error)
{
   TStringList *tmp;
   AnsiString s,TxtFile;
   if (Error)
   {
      //GetBtn->Caption = "Done";
      PageControl1->ActivePage = TabSheet3;
      TStringList *tmp = new TStringList();
      tmp->Add("HTTP Error = "+AnsiString(Error));
      tmp->Add("HTTP Reason = "+HttpCli1->ReasonPhrase);
      TabSet->Tabs->AddObject("Error",tmp);
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      DocMemo->Lines->Text = tmp->Text;
//    while (TabSet->Tabs->Count)
//    {
//       DocMemo->Clear();
//       TStringList *tmp = (TStringList*)TabSet->Tabs->Objects[0];
//       TabSet->Tabs->Delete(0);
//       delete tmp;
//    }
      UrlsBtn->Enabled = true;
      return;
   }
   switch (RqType)
   {
      case httpHEAD:
      {
         //sm(HttpCli1->RcvdHeader->Text);
         for (int i=0; i<HttpCli1->RcvdHeader->Count; i++)
         {
            s = HttpCli1->RcvdHeader->Strings[i];
            if (s.Pos("Content-Length: ")==1)
               BytesTotal = s.SubString(17,16).ToIntDef(0);
         }
         HttpCli1->GetASync();
         break;
      }
      case httpGET:
      {
         tmp = new TStringList();
         HttpCli1->RcvdStream->Seek(0,soFromBeginning);
         tmp->LoadFromStream(HttpCli1->RcvdStream);
         int idx = TabSet->Tabs->IndexOf(CurDoc);
         if (idx>=0)
         {  // this is already downloaded & needs to be replaced
            TStringList *old = (TStringList*)TabSet->Tabs->Objects[idx];
            TabSet->Tabs->Objects[idx] = (TObject*)tmp;
            delete old;
         }
         else
         {  // new doc
            TabSet->Tabs->AddObject(CurDoc,tmp);
            idx = TabSet->Tabs->Count-1;
         }
         TabSet->TabIndex = idx;
         // handle html
         AnsiString doc = tmp->Text.UpperCase();
         if (doc.Pos("<HTML>") && doc.Pos("<PRE>") && doc.Pos("</PRE>"))
         {
            while (tmp->Count && tmp->Strings[0].UpperCase().Trim()!="<PRE>")
               tmp->Delete(0); if (tmp->Count) tmp->Delete(0);
            while (tmp->Count && tmp->Strings[tmp->Count-1].UpperCase().Trim()!="</PRE>")
               tmp->Delete(tmp->Count-1);
            if (tmp->Count) tmp->Delete(tmp->Count-1);
         }
         // end handle html
         DocMemo->Lines->Text = tmp->Text;
         DocMemo->SelStart = 0;
         CurBox->Enabled = false;
         Label1->Caption = "";
         Application->ProcessMessages();
         Sleep(hsleep);
         // test validity of documents...
         GetBtn->Click();
         delete HttpCli1->RcvdStream;
         HttpCli1->RcvdStream = NULL;
         break;
      }
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall THttpForm::GetDefaultURL(AnsiString &path)
{
   AnsiString URL;
   TStringList *urls = new TStringList(); GetAppData(urls,path);
   if (urls->Count) URL = urls->Strings[0];
   delete urls;
   return URL;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetAppURLs()
{
   if ((MListURL = GetDefaultURL(StatsURLs+PS+MListTxt))=="") {
      MListBox->Checked=false; MListBox->Enabled=false;
   } else MListBox->Enabled=true;

   if ((MRingURL = GetDefaultURL(StatsURLs+PS+MRingTxt))=="") {
      MRingBox->Checked=false; MRingBox->Enabled=false;
   } else MRingBox->Enabled=true;

   if ((MTyp2URL = GetDefaultURL(StatsURLs+PS+MTyp2Txt))=="" || ErrorCheck->Checked) {
      MTyp2Box->Checked=false; MTyp2Box->Enabled=false;
   } else MTyp2Box->Enabled=true;

   if ((CListURL = GetDefaultURL(StatsURLs+PS+CListTxt))=="") {
      CListBox->Checked=false; CListBox->Enabled=false;
   } else CListBox->Enabled=true;

   if ((CRingURL = GetDefaultURL(StatsURLs+PS+CRingTxt))=="") {
      CRingBox->Checked=false; CRingBox->Enabled=false;
   } else CRingBox->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::CancelBtnClick(TObject *Sender)
{
   Timer1->Enabled = false; Label1->Caption = "";
   OkBtn->Enabled = true;
   Attended = true;
   if (!GetBtn->Enabled)
   {
      GetBtn->Enabled = true;
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      CancelAnyway = true;
      HttpCli1->Abort();
      Attended = true;
      return;
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer1Timer(TObject *Sender)
{
   if (Label1->Caption=="") Label1->Caption = Cap; else Label1->Caption = "";
   Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ProxyPswdBoxClick(TObject *Sender)
{
   if (!ProxyPswdBox->Checked)
      ProxyPswdEdit->PasswordChar = '\0';
   else
      ProxyPswdEdit->PasswordChar = '*';
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::PageControl1Changing(TObject *Sender,
  bool &AllowChange)
{
   if (PageControl1->ActivePage==TabSheet3)
      ActiveControl = DocMemo;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::UrlsBtnClick(TObject *Sender)
{
   ManageURLs(this);
   GetAppURLs();
}
//---------------------------------------------------------------------------
#define TABSTRINGS(i) ((TStrings*)TabSet->Tabs->Objects[i])
void __fastcall THttpForm::TabSetChange(TObject *Sender, int NewTab,
   bool &AllowChange)
{
   bool locked=LockWindowUpdate(Handle);
   int idx = TabSet->TabIndex;
   if (idx>=0) TABSTRINGS(idx)->Text = DocMemo->Lines->Text;
   DocMemo->Lines->Text = TABSTRINGS(NewTab)->Text;
   DocMemo->SelStart = 0;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormResize(TObject *Sender)
{
   CancelBtn->Left = Width - 95;
   OkBtn->Left = Width - 179;
   GetBtn->Left = Width - 265;
   ProgressBar1->Width = Width - 297;
   Label1->Top = Height - 74;
   Label1->Width = Width - 42;//ProgressBar1->Left+(ProgressBar1->Width/2)-(Label1->Width/2);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ErrorCheckClick(TObject *Sender)
{
  if (ErrorCheck->Checked)
  {
     MTyp2Box->Checked = false; MTyp2Box->Enabled = false;
     CTyp1Box->Visible = true;
  }
  else
  {
     CTyp1Box->Visible = false;
     MTyp2Box->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::RemHlpBtnClick(TObject *Sender)
{
   OpenHelp("Remailer","Remailers & Remailer Documents","Introduction",Application->MainForm);
}
//---------------------------------------------------------------------------
