#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#ifndef HttpDlgH
#define HttpDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <HttpProt.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Tabs.hpp>
#include "explbtn.hpp"
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
bool __fastcall GetRemailerStats(TForm *parent, bool attended=true);
char* __fastcall MixGetNewRemailerKeys(char *KeyDoc);
char* __fastcall MixAddNewRemailerKeys(char *KeyDoc);
bool __fastcall GenerateType1List(TStrings *Keys); // keys in individual keyy blocks
void __fastcall GenerateType2List(TStrings *Keys);

class THttpForm : public TForm
{
__published:	// IDE-managed Components
	THttpCli *HttpCli1;
  TPanel *Panel2;
  TProgressBar *ProgressBar1;
  TButton *GetBtn;
  TButton *CancelBtn;
  TTimer *Timer1;
  TTimer *Timer2;
   TPanel *Panel1;
   TPageControl *PageControl1;
   TTabSheet *TabSheet1;
   TGroupBox *MixmasterGrp;
   TCheckBox *MTyp2Box;
   TCheckBox *MRingBox;
   TCheckBox *MListBox;
   TGroupBox *CyberpunkGrp;
   TCheckBox *CRingBox;
   TCheckBox *CListBox;
   TButton *UrlsBtn;
   TTabSheet *TabSheet2;
   TLabel *Label2;
   TLabel *Label3;
   TLabel *Label4;
   TLabel *Label5;
   TLabel *Label6;
   TEdit *ProxyHostEdit;
   TEdit *ProxyPortEdit;
   TEdit *ProxyPswdEdit;
   TEdit *ProxyUserEdit;
   TCheckBox *ProxyPswdBox;
   TTabSheet *TabSheet3;
   TTabSet *TabSet;
   TLabel *Label1;
  TButton *OkBtn;
  TTabSheet *TabSheet4;
  TGroupBox *MixErrorGrp;
  TCheckBox *MixSyncTyp2Box;
  TCheckBox *MixRepNewBox;
  TCheckBox *MixUpdRingBox;
  TGroupBox *CpunkErrorGrp;
  TCheckBox *CpunkUpdRingBox;
  TCheckBox *CpunkErrorCheck;
  TCheckBox *MixErrorCheck;
  TCheckBox *CpunkRepNewBox;
  TCheckBox *MixListBox;
  TCheckBox *MixRingBox;
  TCheckBox *MixTyp2Box;
  TLabel *Label8;
  TCheckBox *CpunkListBox;
  TCheckBox *CpunkRingBox;
  TLabel *Label9;
  TLabel *Label10;
  TLabel *Label11;
  TLabel *Label12;
  TLabel *Label13;
  TButton *Button1;
  TCheckBox *CpunkSyncTyp1Box;
  TCheckBox *CpunkTyp1Box;
  TBitBtn *BitBtn2;
  TCheckBox *ErrorCheck;
  TLabel *Label7;
  TLabel *Label15;
  TBitBtn *RemHlpBtn;
  TRichEdit *DocMemo;
  TCheckBox *CTyp1Box;
	void __fastcall GetBtnClick(TObject *Sender);
	void __fastcall HttpCli1DocBegin(TObject *Sender);
	void __fastcall HttpCli1DocEnd(TObject *Sender);
	void __fastcall HttpCli1RequestDone(TObject *Sender, THttpRequest RqType,
   	WORD Error);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len);
  void __fastcall CancelBtnClick(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall ProxyPswdBoxClick(TObject *Sender);
  void __fastcall PageControl1Changing(TObject *Sender, bool &AllowChange);
  void __fastcall Timer2Timer(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall UrlsBtnClick(TObject *Sender);
  void __fastcall TabSetChange(TObject *Sender, int NewTab, bool &AllowChange);
  void __fastcall FormResize(TObject *Sender);
  
  void __fastcall ErrorCheckClick(TObject *Sender);
  void __fastcall RemHlpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
   TStrings *Tabs;
   AnsiString CurDoc;
   TCheckBox *CurBox;
   double BytesTotal;
   long BytesReceived;
   AnsiString Cap,Http,
      MListURL,MRingURL,MTyp2URL,
      CListURL,CRingURL;
   bool Attended,Cancelled,CancelAnyway;
   __fastcall THttpForm(TComponent* Owner);
   void __fastcall LoadHttpInfo();
   void __fastcall StoreHttpInfo();
   void __fastcall SaveStatistics();
   bool __fastcall MixKeyringHasDoubles();
   void __fastcall InitCheckmarks();
   bool __fastcall Execute(bool attended);
   void __fastcall GetAppURLs();
   AnsiString __fastcall GetDefaultURL(AnsiString &path);
   bool __fastcall GetStatistics(AnsiString &forURL, TCheckBox *Box, AnsiString &Doc);
   void __fastcall ResetCheckboxes();
   // error checking
   TStringList* __fastcall GetDoc(AnsiString &Docname);
   bool __fastcall GotDoc(AnsiString &Docname);
   bool __fastcall MListOk(TStrings *doctxt);
   bool __fastcall MRingOk(TStrings *doctxt);
   bool __fastcall MTyp2Ok(TStrings *doctxt);
   bool __fastcall CListOk(TStrings *doctxt);
   bool __fastcall CRingOk(TStrings *doctxt);
   // Mix functions. Pgp counterparts in QSpgp.cpp
//   char* __fastcall MixAddNewRemailerKeys(TStrings *KeyDoc);
//   bool __fastcall ErrorMixmasterDocs(TStrings *ErrLog);
//   bool __fastcall ErrorCyberpunkDocs(TStrings *ErrLog);
//   int __fastcall MlistTxtErr(TStrings *Doc, TStrings *ErrLog);
//   int __fastcall PubringMixErr(TStrings *Doc, TStrings *ErrLog);
//   int __fastcall Type2ListErr(TStrings *Doc, TStrings *ErrLog);
};

bool __fastcall MRingLineOk(AnsiString &line);
//---------------------------------------------------------------------------
extern THttpForm *HttpForm;
//---------------------------------------------------------------------------
#endif
