//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\printers.hpp>
#pragma hdrstop

#include "PrintDlg.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPrintForm *PrintForm;
#define WAITMSG "  Wait..."
#define PRNTMSG "  Printing..."
//---------------------------------------------------------------------------
void __fastcall PrintMessage(TStrings *Lines, TFont *Font, AnsiString &Title, TForm *Form)
{
   PrintForm = new TPrintForm(Form);
   PrintForm->Lines->Text = Lines->Text;
   PrintForm->Caption = Title;
   PrintForm->Font = Font;
   PrintForm->ShowModal();
   delete PrintForm;
}
//---------------------------------------------------------------------------
__fastcall TPrintForm::TPrintForm(TComponent* Owner)
	: TForm(Owner)
{
   // Center in Main Window
   TForm *Main = (TForm*)Owner;
   Top = Main->Top+((Main->Height-Height)/2);
   Left = Main->Left+((Main->Width-Width)/2);
   // initialize
   Lines = new TStringList();
   msg->Caption = WAITMSG;
   Cancelled = false;
   Printing = false;
}
//---------------------------------------------------------------------------
void __fastcall TPrintForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk) Printer()->EndDoc(); else Printer()->Abort();
   Timer1->Enabled = false;
   delete Lines;
}
//---------------------------------------------------------------------------
void __fastcall TPrintForm::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPrintForm::Timer1Timer(TObject *Sender)
{
   if (msg->Caption==WAITMSG) msg->Caption = ""; else
   if (msg->Caption=="") msg->Caption=PRNTMSG; else msg->Caption="";
   if (!Printing) PrintLines();
}
//---------------------------------------------------------------------------
void __fastcall TPrintForm::PrintLines()
{
   AnsiString pageStr;
   int i,page,xpos,ypos,xpag,ypag;
   TCanvas *canvas = Printer()->Canvas;
   int pagewidth = Printer()->PageWidth;
   int pageheight = Printer()->PageHeight;

   Printing = true;
   Printer()->Orientation = poPortrait;
   Printer()->BeginDoc();
   Printer()->Canvas->Font->Name = Font->Name;
   Printer()->Canvas->Font->Size = Font->Size;
   page = 1;
   xpos = lmargin;
   ypos = tmargin;

   for (i=0; i<Lines->Count; i++)
   {
      Application->ProcessMessages();
      if (Cancelled) break;

      if (ypos==tmargin)
      {
         if (Lines->Strings[i].IsEmpty()) continue;

         pageStr = "Page "+String(page);
         xpag = (pagewidth/2)-(canvas->TextWidth(pageStr)/2);
         ypag = pageheight-(bmargin/2);
         canvas->TextOut(xpag,ypag,pageStr);
      }

      canvas->TextOut(xpos,ypos,Lines->Strings[i]);
      ypos = ypos+canvas->TextHeight('Yy')+between;
      if (ypos>pageheight-bmargin)
      {
         ypos = tmargin;
         Printer()->NewPage();
         page++;
      }
   }

   ModalResult = Cancelled ? mrCancel : mrOk;
   Timer1->Enabled = false;
   msg->Caption = "Job Complete!";
   CancelBtn->Enabled = false;
   Application->ProcessMessages();
   Sleep(500);
}
//---------------------------------------------------------------------------
void __fastcall TPrintForm::CancelBtnClick(TObject *Sender)
{
   Cancelled = true;
}
//---------------------------------------------------------------------------
