//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "qspgpver.h"
#include "pgprecips.h"
#include "PgpPassEx.h"
#include "pgpfiles.h"
#include "global.h"
#include "fileman.h"
#include "headman.h"
#include "pgpdlg.h"
#include "MixmastDlg.h"
#include "pgp.h"

USERES("QSPGP.res");
USEUNIT("QSpgpVer.cpp");
USEFORM("PgpRecips.cpp", PgpRecipForm);
USEFORM("Wiper.cpp", WipeForm);
USEUNIT("pgp.cpp");
USEUNIT("Global.cpp");
USEUNIT("Mixmaster.cpp");
USEUNIT("Console.cpp");
USEUNIT("Fmxutils.cpp");
USEFORM("PGPpassEx.cpp", PgpPassForm);
USEUNIT("FileMan.cpp");
USEUNIT("HeadMan.cpp");
USEFORM("MixmastDlg.cpp", MixForm);
USEFORM("PgpDlg.cpp", PgpForm);
USEUNIT("PgpFiles.cpp");
USELIB("zlib.LIB");
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __fastcall PgpInit(HINSTANCE HMixLib,
   HINSTANCE HSSLLib, TForm *MainForm, HWND AppHandle);
extern "C" __declspec(dllexport) char* __fastcall PgpSignMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptSignMessage(char *Message);
//returns only _new_ keys, not keys already in rem keyring
extern "C" __declspec(dllexport) char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc);
// returns new type1.list and saves new keyring in CRingTmp
extern "C" __declspec(dllexport) char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc);
extern "C" __declspec(dllexport) void  __fastcall GenerateType1List(char *KeyDoc);
// gets individually armored keys
extern "C" __declspec(dllexport) char* __fastcall PgpArmorBlockToArmorKeys(char *keys);
extern "C" __declspec(dllexport) char* __fastcall PgpArmorKeysToArmorBlock(char *keys);

extern "C" __declspec(dllexport) char* __fastcall GetPgpLibVersion();
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibName();
bool __fastcall CutMessageAtCutmarks(TStrings *msg);
// string for returning char*s
AnsiString retbuf;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   hMixLib=HMixLib; hSSLLib=HSSLLib;
   Application->Handle=AppHandle;
   ActMainForm=MainForm;
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorKeysToArmorBlock(char *keys)
{
   retbuf = "";
   AnsiString line;
   BUFFER *db=buf_new(),*bin=buf_new(),*armor=buf_new();
   TStringList *Keys = new TStringList();
   Keys->SetText(keys);
   bool inkey=false;
   for (int i=0; i<Keys->Count; i++)
   {
      line = Keys->Strings[i];
      if (line.Trim()=="-----BEGIN PGP PUBLIC KEY BLOCK-----") inkey = true;
      if (inkey) { line += "\r\n"; buf_appends(armor,line.c_str()); }
      if (line.Trim()=="-----END PGP PUBLIC KEY BLOCK-----")
      {
         pgp_dearmor(armor,bin);
         buf_cat(db,bin);
         buf_clear(armor);
         inkey = false;
      }
   }
   pgp_armor(db,2);
   retbuf = AnsiString((char*)db->data);
   delete Keys;
   buf_free(bin);
   buf_free(db);
   return retbuf.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeys(char *keyblock)
{
   retbuf = "";
   AnsiString filename = CRingTmp;
   if (FileExists(filename)) DeleteFile(filename.c_str());
   TStringList *block = new TStringList();
   block->SetText(keyblock);
   block->SaveToFile(filename);
   delete block;

   if (FileExists(filename))
   {
      TStringList *keys = new TStringList();
      TPgpDb *pgpdb = new TPgpDb(filename,"");
      TPgpKey *key = pgpdb->FirstKey();
      TStringList *akey = new TStringList();
      while (key)
      {
         BUFFER *armored = buf_new();
         buf_set(armored,key->Key);
         pgp_armor(armored,2);
         akey->SetText((char*)armored->data);
         if (akey->Count)
         {
            akey->Insert(0,key->Description+"\n");
            akey->Add("");
            keys->AddStrings(akey);
         }
         key = key->Next;
         akey->Clear();
      }
      delete akey;
      delete pgpdb;
      DeleteFile(filename.c_str());
      retbuf = keys->Text;
      delete keys;
   }
   return retbuf.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc)
{ // this function respects 'disabled' remailers in type1.list
   retbuf = "";
   AnsiString line,cringtxt=MixDir()+CRingTxt,ctyp1txt=MixDir()+CTyp1Txt;
   TStringList *dockeys = new TStringList();
   dockeys->SetText(KeyDoc);
   dockeys->SaveToFile(CRingTmp);
   delete dockeys;

   TStringList *type1 = new TStringList();
   TStringList *newkeys = new TStringList();
   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);

   TPgpDb *curdb = new TPgpDb(cringtxt,"");
   TPgpDb *newdb = new TPgpDb(CRingTmp,"");
   TPgpKey *key = newdb->FirstKey();
   while (key)
   {
      bool add=false;
      if (curdb->Find(key)<0)
      {
         add = true;
         for (int i=0; i<type1->Count; i++)
         {
            line = type1->Strings[i];
            if (line.Length() && line[1]=='#' && line.Pos(" 0x"+key->IdText8+" ")>=0)
            {
               add = false;
               break;
            }
         }
      }
      if (add) newkeys->Add(key->Description);
      key = key->Next;
   }

   if (FileExists(CRingTmp)) DeleteFile(CRingTmp.c_str());
   AnsiString newKeys = newkeys->Text;
   delete newdb;
   delete curdb;
   delete type1;
   delete newkeys;
   return newKeys.c_str();
}
//---------------------------------------------------------------------------
bool __fastcall CRingLineOk(AnsiString &line)
{
   return line.Pos("0x")>0;
}
//---------------------------------------------------------------------------
void  __fastcall GenerateType1List(char *KeyDoc)
{
   AnsiString ctyp1txt = MixDir()+CTyp1Txt;
   TStringList *type1 = new TStringList();
   TStringList *keys = new TStringList();
   keys->SetText(KeyDoc);

   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);
   int i=0; while(i<type1->Count)
   {
      if (type1->Strings[i].Pos("#")!=1) type1->Delete(i);
      else i++;
   }
   for (i=0; i<keys->Count; i++)
   {
      AnsiString line = keys->Strings[i];
      if (CRingLineOk(line) && type1->IndexOf("#"+line)<0)
         type1->Add(line);
   }
   type1->SaveToFile(ctyp1txt);
   delete keys;
   delete type1;
}
//---------------------------------------------------------------------------
char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc)
{ // newly downloaded pubring.asc
   retbuf = "";
   AnsiString line,cringtxt=MixDir()+CRingTxt,ctyp1txt=MixDir()+CTyp1Txt;
   TStringList *dockeys = new TStringList();
   dockeys->SetText(KeyDoc);
   dockeys->SaveToFile(CRingTmp); // save as tmpring so not to replace pubring.asc
   delete dockeys;

   int i;
   TStringList *type1 = new TStringList();
   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);
   if (!FileExists(cringtxt))
   {
      FILE *f = fopen(cringtxt.c_str(),"a+"); // create empty file
      fclose(f);
   }
   // open pubring.asc and tmpring.asc
   TPgpDb *curdb = new TPgpDb(MixDir()+CRingTxt,"");
   TPgpDb *newdb = new TPgpDb(CRingTmp,"");
   TPgpKey *key = newdb->FirstKey();
   // cycle through tmpring looking for new keys;
   while (key)
   {
      bool add=false;
      if (curdb->Find(key)<0) // <0 == newkey
      {
         add = true;
         for (i=0; i<type1->Count; i++)
         {
            line = type1->Strings[i];
            // check if this is a disabled key and flag
            if (line.Length() && line[1]=='#' && line.Pos(" 0x"+key->IdText8+" ")>=0)
            {
               add = false;
               break;
            }
         }
      }
      // add this key to the current database
      if (add) curdb->AppendDb(key->Key);
      key = key->Next;
   }
   // Update the type1.list
   //===========================
   // delete all entries except #'s
   i=0; while(i<type1->Count)
   {
      if (!type1->Strings[i].Pos("#")) type1->Delete(i);
      else i++;
   }
   // check each description for !disabled and add
   key = curdb->FirstKey();
   while (key)
   {
      line = key->Description;
      if (type1->IndexOf("#"+line)<0) type1->Add(line);
      key = key->Next;
   }
   // setup new type1 to pass back
   retbuf = type1->Text;
   delete newdb;
   delete curdb; // this saves the modified keyring in ascii-armor
   delete type1;
   return retbuf.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptMessage(char *Message)
{
   retbuf = "";
   AnsiString passphrase;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   TStringList *recips = new TStringList();
   THeaderManager *Headers = new THeaderManager(msg);
   Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;

   if (!PGPgetEncryptList(recips))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   bool cEncrypt = recips->Text==UseConventional+"\r\n";
   if (cEncrypt && !PGPgetConventionalPassphrase(passphrase,ActMainForm))
   {
      delete recips;
      delete msg;
      return NULL;
   }
   CutMessageAtCutmarks(msg);
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx>=msg->Count || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(AppMainForm->Handle,
         AnsiString("Your message does not appear to have an empty\n")+
         AnsiString("line between headers and body!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete msg;
      return NULL;
   }

   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }

   int result=16; // just a non-error number
   if (mail->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      if (cEncrypt)
         result = Pgp->EncryptCMessage(mail,passphrase);
      else
         result = Pgp->EncryptMessage(mail,recips);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to encrypt!","QS PGP Encrypt Error",
         MB_OK);

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      retbuf = msg->Text;
   }

   delete mail;
   delete recips;
   delete msg;
   return retbuf.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptSignMessage(char *Message)
{
   retbuf = "";
   AnsiString passphrase;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   TStringList *recips = new TStringList();
   THeaderManager *Headers = new THeaderManager(msg);
   AnsiString keyid=Headers->GetDat("From: ");
   Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;
   // get list of public keys
   if (!PGPgetEncryptList(recips,NotConventional))
   {
      delete recips;
      delete msg;
      return NULL;
   }
   /*// check for conventional encryption
   bool cEncrypt = recips->Text==UseConventional+"\r\n";
   if (cEncrypt && !PGPgetConventionalPassphrase(passphrase,ActMainForm))
   {
      delete recips;
      delete msg;
      return NULL;
   }*/
   // open keyrings for signing key
   TStringList *keys = new TStringList();
   TPgpDb *pgpdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   TPgpKey *Key = pgpdb->FirstKey();
   while (Key)
   {
      if (Key->IsPair)
      {
         TPgpKey *skey = Key->SecKey;
         if (skey->UserIds->Count)
         {
            for (int i=0; i<skey->UserIds->Count; i++)
               keys->Add(skey->UserIds->Strings[i]);
         }
      }
      Key = Key->Next;
   }
   delete pgpdb;
   // fail job if no secret keys
   if (!keys->Count)
   {
      MsgBox("No keys found!","QS PGP Error",MB_OK);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   // pause
   Application->ProcessMessages(); Sleep(200);
   // keys ok, get sign key and passphrase
   int current=keys->IndexOf(keyid);
   int clearsign = GetAppIni(ClearSignMessage,"").ToIntDef(0);
   if (!PGPgetKeyidAndPassphrase(keys,current,passphrase,clearsign,ActMainForm))
   {
      delete keys;
      delete msg;
      return NULL;
   }
   if (current>=0 && current<keys->Count)
      keyid = keys->Strings[current];
   // ok we have the key, parse it
   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1;
   keyid = keyid.SubString(first,last?last-(first-1):keyid.Length());
   // prepare message
   CutMessageAtCutmarks(msg);
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx>=msg->Count || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(AppMainForm->Handle,
         AnsiString("Your message does not appear to have an empty\n")+
         AnsiString("line between headers and body!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete msg;
      return NULL;
   }

   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }

   int result=16; // just a non-error number
   if (mail->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      result = Pgp->EncryptSignMessage(mail,keyid,passphrase,recips,clearsign);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to sign!","PGP Error",MB_OK);

   if (result==PGP_OK)
   {
      PutAppIni(ClearSignMessage,clearsign?"1":"0");
      msg->AddStrings(mail); mail->Clear();
      retbuf = msg->Text;
   }

   delete mail;
   delete keys;
   delete recips;
   delete msg;
   return retbuf.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   retbuf = "";
   TStringList *msg = new TStringList(); msg->SetText(Message);
   TStringList *recips = new TStringList();
   THeaderManager *Headers = new THeaderManager(msg);
   AnsiString keyid=Headers->GetDat("From: ");
   Headers->GetRecipsFull("To: ",recips);
   delete Headers;

   TStringList *keys = new TStringList();
   TPgpDb *pgpdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   TPgpKey *Key = pgpdb->FirstKey();
   while (Key)
   {
      if (Key->IsPair)
      {
         TPgpKey *skey = Key->SecKey;
         if (skey->UserIds->Count)
         {
            for (int i=0; i<skey->UserIds->Count; i++)
               keys->Add(skey->UserIds->Strings[i]);
         }
      }
      Key = Key->Next;
   }
   delete pgpdb;
   if (!keys->Count)
   {
      MsgBox("No keys found!","QS PGP Error",MB_OK);
      delete keys;
      delete msg;
      return NULL;
   }

   AnsiString passphrase;
   int current=keys->IndexOf(keyid);
   if (!PGPgetKeyidAndPassphrase(keys,current,passphrase,2,ActMainForm))
   {
      delete keys;
      delete msg;
      return NULL;
   }
   if (current>=0 && current<keys->Count)
      keyid = keys->Strings[current];
   // ok we have the key, parse it
   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1;
   keyid = keyid.SubString(first,last>=0?last-(first-1):keyid.Length());
   CutMessageAtCutmarks(msg);
   int result=16; // just a non-error number
   if (msg->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      Pgp->ToRemailer = Pgp->IsRemailed(recips); // to test for remailer address
//sm(s(first)+"  '"+keyid+"'  "+s(last));
      result = Pgp->SignMessage(msg,keyid,passphrase);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to sign!","PGP Sign Error",MB_OK);

   if (result==PGP_OK) retbuf = msg->Text;
   delete recips;
   delete keys;
   delete msg;
   return retbuf.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   while (msg->Count && msg->Strings[msg->Count-1].IsEmpty())
      msg->Delete(msg->Count-1);
   return cut;
}
//---------------------------------------------------------------------------

